<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <style>
    :root {
      --spacing: 0.8rem;
    }
    * {
      box-sizing: border-box;
    }
    body {
      background-color: var(--figma-color-bg);
      color: var(--figma-color-text);
      font-family: system-ui, -apple-system, BlinkMacSystemFont, "Segoe UI",
        Roboto, Oxygen, Ubuntu, Cantarell, "Open Sans", "Helvetica Neue",
        sans-serif;
      margin: 0;
      padding: var(--spacing);
    }
    html,
    body {
      height: 100%;
    }
    form {
      display: flex;
      flex-direction: column;
      gap: var(--spacing);
    }
    button {
      appearance: none;
      border-radius: 4px;
      padding: var(--spacing);
    }
    select {
      color: var(--figma-color-text);
      appearance: none;
    }
    input,
    textarea,
    select {
      font-family: Andale Mono, monospace;
      font-size: 0.9rem;
      padding: var(--spacing);
    }
    textarea {
      flex: 1;
      white-space: pre;
    }
    form > * {
      display: block;
      width: 100%;
    }
    button {
      background-color: var(--figma-color-bg-brand);
      border: none;
      color: var(--figma-color-text-onbrand);
      font-weight: bold;
      display: block;
      width: 100%;
      cursor: pointer;
    }
    button:disabled {
      cursor: not-allowed;
      opacity: 0.6;
    }
    .secondary {
      background-color: var(--figma-color-bg-secondary);
      border: 1px solid var(--figma-color-border-brand);
      color: var(--figma-color-text-brand);
    }
    input,
    textarea,
    select {
      background-color: var(--figma-color-bg-secondary);
      color: var (--figma-color-text-secondary);
      border: 2px solid var (--figma-color-border);
    }
    input:focus,
    textarea:focus,
    select:focus {
      border-color: var (--figma-color-border-selected);
      outline: none;
    }
    .hidden {
      display: none;
    }
    #loader {
      display: none;
      border: 2px solid var(--figma-color-bg);
      border-top: 2px solid var(--figma-color-bg-brand);
      border-radius: 50%;
      width: 20px;
      height: 20px;
      animation: spin 1s linear infinite;
      margin: 10px auto;
    }
    @keyframes spin {
      0% { transform: rotate(0deg); }
      100% { transform: rotate(360deg); }
    }
  </style>
</head>
<body>
  <form>
    <select id="collectionsDropdown">
      <option value="" disabled selected>Select a collection...</option>
    </select>
    <input type="text" name="newCollectionName" id="newCollectionName" class="hidden" placeholder="New collection name...">
    <input type="file" id="fileInput" accept=".json" multiple>
    <label for="flattened">Flatten Tokens <input type="checkbox" id="flattened" checked></label>
    <button type="submit">Import Variables</button>
  </form>

  <div id="loader"></div>
  <button class="secondary" id="generateTable">Generate Table</button>
  <div id="status"></div>

  <ul id="display" class="hidden">
    <li>Created: <span id="created">0</span></li>
    <li>Updated: <span id="updated">0</span></li>
    <li>Skipped: <span id="skipped">0</span></li>
    <li>Invalid: <span id="invalid">0</span></li>
  </ul>

  <script>
    let tokenData = null;

    onmessage = (event) => {
      const message = event.data.pluginMessage;
      console.log("Received message from plugin:", message);

      if (message.type === 'VARIABLE_COLLECTIONS') {
        const collectionsDropdown = document.querySelector('#collectionsDropdown');
        
        // Remove all options except the default ones
        collectionsDropdown.querySelectorAll('option:not([value=""])').forEach(option => option.remove());

        message.collections.forEach((collection) => {
          const option = document.createElement('option');
          option.value = collection.id;

          const displayName = collection.name + ' (' + collection.id.split(':').slice(1).join(':') + ')';
          option.textContent = displayName || collection.id;

          collectionsDropdown.appendChild(option);
        });

        if (message.activeCollectionId) {
          document.querySelector('#newCollectionName').classList.add('hidden');
          document.querySelector('#collectionsDropdown').value = message.activeCollectionId;
        }
      } else if (message.type === 'IMPORT_COMPLETE') {
        updateStatus(message);
        document.getElementById('loader').style.display = 'none';
        document.getElementById('generateTable').disabled = false;
      } else if (message.type === 'TABLE_GENERATED') {
        document.getElementById('status').textContent = message.message;
        document.getElementById('loader').style.display = 'none';
        document.getElementById('generateTable').disabled = false;
        console.log("Updated UI: hidden loader, enabled button, displayed success message");
      } else if (message.type === 'ERROR') {
        document.getElementById('status').textContent = message.message;
        document.getElementById('loader').style.display = 'none';
        document.getElementById('generateTable').disabled = false;
        console.log("Updated UI: hidden loader, enabled button, displayed error message");
      }
    }

    function updateStatus(message) {
      const display = document.querySelector("#display");
      display.classList.remove("hidden");
      document.querySelector("#created").textContent = message.created;
      document.querySelector("#updated").textContent = message.updated;
      document.querySelector("#skipped").textContent = message.skipped;
      document.querySelector("#invalid").textContent = message.invalid;

      const status = `${message.created} created, ${message.updated} updated, ${message.skipped} skipped, ${message.invalid} invalid`;
      document.getElementById('status').textContent = status;
    }

    document.querySelector("form").addEventListener("submit", (e) => {
      e.preventDefault();
      const flattened = document.querySelector('#flattened').checked;
      const selectedCollectionId = document.querySelector('#collectionsDropdown').value;
      if (!selectedCollectionId) {
        alert('Please select a collection.');
        return;
      }
      const fileInput = document.querySelector('#fileInput');
      const selectedFiles = fileInput.files;

      if (selectedFiles.length > 0) {
        document.getElementById('loader').style.display = 'block';
        const allFilePromises = Array.from(selectedFiles).map(file => {
          return new Promise((resolve, reject) => {
            if (file.type === 'application/json') {
              const reader = new FileReader();
              reader.onload = function (e) {
                try {
                  const fileContents = e.target.result;
                  const jsonData = JSON.parse(fileContents);
                  resolve(jsonData);
                } catch (error) {
                  reject('Error parsing JSON in file: ' + file.name);
                }
              };
              reader.readAsText(file);
            } else {
              reject('Invalid file type: ' + file.name);
            }
          });
        });

        Promise.all(allFilePromises)
          .then(jsonDataArray => {
            const combinedJsonData = jsonDataArray.reduce((acc, jsonData) => {
              return { ...acc, ...jsonData };
            }, {});
            console.log(combinedJsonData);
            parent.postMessage(
              { pluginMessage: { type: "IMPORT", collectionId: selectedCollectionId, data: combinedJsonData, flattened: flattened } },
              "*"
            );
          })
          .catch(error => {
            console.error('Error processing files:', error);
            document.getElementById('loader').style.display = 'none';
          });
      } else {
        alert('Please select files to upload.');
      }
    });

    document.getElementById('generateTable').onclick = () => {
      console.log("Generate Table button clicked");
      document.getElementById('loader').style.display = 'block';
      document.getElementById('generateTable').disabled = true;
      console.log("Updated UI: shown loader, disabled button");
      parent.postMessage({ pluginMessage: { type: 'GENERATE_TABLE' } }, '*');
      console.log("Sent GENERATE_TABLE message to plugin");
    }
  </script>
</body>
</html>
